#include <stdio.h>
#include <string.h>
#include <rpc/rpc.h>
#define DATE_PROG 0x31234567
#define DATE_VERS 1
#define BIN_DATE 1
#define STR_DATE 2
long bin_date (void);
char *str_date (long);
char *server;
int
main (int argc, char **argv)
{
  long lresult;
  char *sresult;
  if (argc != 2)
    {
      fprintf (stderr, "uso: %s hostname\n", argv[0]);
      return -1;
    }

  server = argv[1];
  lresult = bin_date ();
  printf ("hora en %s = %ld\n", server, lresult);
  sresult = str_date (lresult);
  printf ("hora en %s = %s\n", server, sresult);
  return 0;
}

long
bin_date ()
{
  long timeval;
  if (callrpc
      (server, DATE_PROG, DATE_VERS, BIN_DATE, xdr_void, 0, xdr_long,
       &timeval) != 0)
    {
      fprintf (stderr, "bin_date ha fallado\n");
      return -1;
    }
  return (timeval);
}

char *
str_date (long bintime)
{
  static char *ptr;
  if (callrpc
      (server, DATE_PROG, DATE_VERS, STR_DATE, xdr_long, &bintime,
       xdr_wrapstring, &ptr) != 0)
    {
      fprintf (stderr, "str_date ha fallado\n");
      return (char *)-1;
    }
  return (ptr);
}
